
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	Colour Segment

	V1.0BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Include file declarations

#include "xvis.h"
#include <string.h>
#include <stdio.h>

#define XSIZE 15
#define YSIZE 15

// ---------------------------------------------
// local forward function declares

// --------------------------------------------
// Callbacks

void func_colourdefault_call(Widget aw, XtPointer client, XtPointer call)
{
	switch (colourmode) {
		case BCOLOUR:
				strcpy(propeditbuffer, "snow");
				colourexample.SetBackground(stringToPixel(colourexample, propeditbuffer));
				break;
		case FCOLOUR:
				strcpy(propeditbuffer, "navy");
				colourexample.SetBackground(stringToPixel(colourexample, propeditbuffer));
				break;
		case TSCOLOUR:
				strcpy(propeditbuffer, "grey90");
				colourexample.SetBackground(stringToPixel(colourexample, propeditbuffer));
				break;
		case BSCOLOUR:
				strcpy(propeditbuffer, "grey45");
				colourexample.SetBackground(stringToPixel(colourexample, propeditbuffer));
				break;
		default:
				break;
	}

}

void func_colourcancel_call(Widget aw, XtPointer client, XtPointer call)
{
	xvisColours.Close();
}

void func_colourlist_call(Widget aw, XtPointer client, XtPointer call)
{
	XawListReturnStruct *val=(XawListReturnStruct *) call;
	strcpy(propeditbuffer, val->string);
	colourexample.SetBackground(stringToPixel(colourexample, propeditbuffer));
}

//---------------------------------------------
// Local Stuff

// ************
// buildColourWindow is the high-level call to display this window.
//
void buildColourWindow(XtCallbackProc confirm)
{
	xvisColours.init("Colours", xvisControl);

	colourform.init("ColourForm", xvisColours);
	colourform.SetBackground("gray85");

	colourview.init("Fontview", colourform, TRUE, FALSE, TRUE);
	colourview.SetFixedPosition(TRUE);
		
	colourlist.init("Fontlist", colourview, func_colourlist_call, 
		numcolours, colournamelist, 4);
	colourlist.SetHeight(300);
	colourlist.SetFixedPosition(TRUE);

	colourexample.init(" ", colourform);
	colourexample.SetWidth(colourlist.GetWidth());
	colourexample.SetRelVertical(colourview);
	colourexample.SetHeight(50);
	colourexample.SetFixedPosition(TRUE);

	int w=colourlist.GetWidth()/2;

	colourok.init("OK", colourform, confirm);
	colourok.SetRelVertical(colourexample);
	colourok.SetWidth(60);
	colourok.SetHorizDistance(w-150);
	colourok.SetFixedPosition(TRUE);
	colourok.SetBeNiceToColormap(FALSE);

	colourcancel.init("Cancel", colourform, func_colourcancel_call);
	colourcancel.SetRelVertical(colourexample);
	colourcancel.SetWidth(60);
	colourcancel.SetHorizDistance(w-30);	 
	colourcancel.SetFixedPosition(TRUE);
	colourcancel.SetBeNiceToColormap(FALSE);

	colourdefault.init("Default", colourform, func_colourdefault_call);
	colourdefault.SetRelVertical(colourexample);
	colourdefault.SetWidth(60);
	colourdefault.SetHorizDistance(w+90);	 
	colourdefault.SetFixedPosition(TRUE);
	colourdefault.SetBeNiceToColormap(FALSE);

	ColoursVisible=TRUE;
}

// ---------------------------------------------
		
